diff -uNrd ircd-hybrid-6.0/include/msg.h ircd-hybrid-6rc7+unitedFreeBg-p1/include/msg.h
--- ircd-hybrid-6.0/include/msg.h	Wed Nov  8 22:46:52 2000
+++ ircd-hybrid-6rc7+unitedFreeBg-p1/include/msg.h	Thu Jan  4 10:23:09 2001
@@ -118,8 +118,12 @@
 #define MSG_HTM      "HTM"      /* HTM */
 #define MSG_SET      "SET"      /* SET */
 
-#define MSG_GLINE    "GLINE"    /* GLINE */
+#ifdef SERVICES
+#define MSG_SERV_ID    "SERVID"  /* SERVID */
+#endif
 
+#define MSG_GLINE    "GLINE"    /* GLINE */
+#define MSG_UNGLINE  "UNGLINE"  /* UNGLINE */
 
 #define MSG_LOCOPS   "LOCOPS"   /* LOCOPS */
 #ifdef LWALLOPS
@@ -239,6 +243,7 @@
   { MSG_UNKLINE, m_unkline,  0, MAXPARA, 1, 0, 0, 0L },
   { MSG_DLINE,   m_dline,    0, MAXPARA, 1, 0, 0, 0L },
   { MSG_GLINE,   m_gline,    0, MAXPARA, 1, 0, 0, 0L },
+  { MSG_UNGLINE, m_ungline,  0, MAXPARA, 1, 0, 0, 0L },
   { MSG_HASH,    m_hash,     0, MAXPARA, 1, 0, 0, 0L },
   { MSG_DNS,     m_dns,      0, MAXPARA, 1, 0, 0, 0L },
   { MSG_REHASH,  m_rehash,   0, MAXPARA, 1, 0, 0, 0L },
@@ -246,6 +251,9 @@
   { MSG_DIE, m_die,          0, MAXPARA, 1, 0, 0, 0L },
   { MSG_HTM,    m_htm,       0, MAXPARA, 1, 0, 0, 0L },
   { MSG_SET,    m_set,       0, MAXPARA, 1, 0, 0, 0L },
+#ifdef SERVICES
+  { MSG_SERV_ID, m_serv_id,  0, MAXPARA, 1, 0, 0, 0L },
+#endif
   { MSG_TESTLINE,       m_testline,          0, MAXPARA, 1, 0, 0, 0L },
   { (char *) 0, (int (*)()) 0 , 0, 0,    0, 0, 0, 0L }
 };
diff -uNrd ircd-hybrid-6.0/include/numeric.h ircd-hybrid-6rc7+unitedFreeBg-p1/include/numeric.h
--- ircd-hybrid-6.0/include/numeric.h	Thu Dec 23 02:10:51 1999
+++ ircd-hybrid-6rc7+unitedFreeBg-p1/include/numeric.h	Thu Oct 25 03:10:39 2001
@@ -204,6 +204,15 @@
 
 #define RPL_LOCALUSERS       265
 #define RPL_GLOBALUSERS      266
+#ifdef SERVICES
+#define RPL_IDENTUSERS       267
+#endif
+#ifdef DCCFILECHECK
+#define RPL_STATSRLINE       268
+#endif
+#ifdef OPERSPOOF
+#define RPL_STATSVLINE       269
+#endif
 
 /* numeric_replies */
 
@@ -234,6 +243,15 @@
 #define RPL_LISTEND          323
 #define RPL_CHANNELMODEIS    324
 
+#ifdef SERVICES
+#define RPL_NS_ID            325
+#define RPL_OS_ID            326
+#define RPL_NK_ID            327
+#ifdef SILENCE_SUPPORT
+#define RPL_SILENCEMODE      328
+#endif
+#endif
+
 #define RPL_CREATIONTIME     329
 
 #define RPL_NOTOPIC          331
@@ -291,12 +309,16 @@
 #define ERR_TOOMANYCHANNELS  405
 #define ERR_WASNOSUCHNICK    406
 #define ERR_TOOMANYTARGETS   407
+#define ERR_NOCOLORSONCHAN   408
 #define ERR_NOORIGIN         409
 
 #define ERR_NORECIPIENT      411
 #define ERR_NOTEXTTOSEND     412
 #define ERR_NOTOPLEVEL       413
 #define ERR_WILDTOPLEVEL     414
+#ifdef SERVICES
+#define ERR_SRV_NICK         415
+#endif
 
 #define ERR_UNKNOWNCOMMAND   421
 #define ERR_NOMOTD           422
@@ -326,6 +348,9 @@
 #define ERR_YOUWILLBEBANNED  466
 #define ERR_KEYSET           467
 
+#ifdef SERVICES
+#define ERR_NICKTOOYOUNG     470
+#endif
 #define ERR_CHANNELISFULL    471
 #define ERR_UNKNOWNMODE      472
 #define ERR_INVITEONLYCHAN   473
@@ -335,6 +360,9 @@
 #define ERR_MODELESS         477        /* ircu numeric -db */
 #define ERR_BANLISTFULL      478        /* I stole the numeric from ircu -db */
 #define ERR_BADCHANNAME      479
+#ifdef SERVICES
+#define ERR_NICKNOTID        480
+#endif
 
 #define ERR_NOPRIVILEGES     481
 #define ERR_CHANOPRIVSNEEDED 482
diff -uNrd ircd-hybrid-6.0/include/patchlevel.h ircd-hybrid-6rc7+unitedFreeBg-p1/include/patchlevel.h
--- ircd-hybrid-6.0/include/patchlevel.h	Wed Jan  3 22:14:27 2001
+++ ircd-hybrid-6rc7+unitedFreeBg-p1/include/patchlevel.h	Fri Jun  7 17:00:08 2002
@@ -17,5 +17,5 @@
  */
 
 #ifndef PATCHLEVEL
-#define PATCHLEVEL    "2.8/hybrid-6.0"
+#define PATCHLEVEL    "2.8/hybrid-6rc7+unitedFreeBg-p1"
 #endif
diff -uNrd ircd-hybrid-6.0/include/s_conf.h ircd-hybrid-6rc7+unitedFreeBg-p1/include/s_conf.h
--- ircd-hybrid-6.0/include/s_conf.h	Fri Dec  1 01:28:47 2000
+++ ircd-hybrid-6rc7+unitedFreeBg-p1/include/s_conf.h	Wed Oct 24 20:28:17 2001
@@ -261,6 +261,12 @@
 #define CONF_DLINE              0x20000
 #define CONF_XLINE              0x40000
 #define CONF_ULINE              0x80000
+#ifdef DCCFILECHECK
+#define CONF_RLINE              0x200000
+#endif
+#ifdef OPERSPOOF
+#define CONF_VLINE              0x400000
+#endif
 
 #define CONF_OPS                (CONF_OPERATOR | CONF_LOCOP)
 #define CONF_SERVER_MASK        (CONF_CONNECT_SERVER | CONF_NOCONNECT_SERVER)
@@ -349,6 +355,17 @@
 extern struct ConfItem *u_conf;
 /* conf xline link list root */
 extern struct ConfItem *x_conf;
+
+#ifdef DCCFILECHECK
+/* conf rline link list root */
+extern struct ConfItem *r_conf;
+#endif
+
+#ifdef OPERSPOOF
+/* conf vline link list root */
+extern struct ConfItem *v_conf;
+#endif
+
 /* conf qline link list root */
 extern struct QlineItem *q_conf;
 
@@ -402,6 +419,9 @@
 extern char *oper_privs_as_string(struct Client *, int);
 extern int rehash_dump(struct Client *);
 extern int find_q_line(char*, char*, char *);
+#ifdef OPERSPOOF
+extern int find_v_line(struct Client *);
+#endif
 extern struct ConfItem* find_special_conf(char *,int );
 extern struct ConfItem* find_is_klined(const char* host, 
                                        const char* name,
diff -uNrd ircd-hybrid-6.0/include/s_misc.h ircd-hybrid-6rc7+unitedFreeBg-p1/include/s_misc.h
--- ircd-hybrid-6.0/include/s_misc.h	Thu Oct  5 23:00:57 2000
+++ ircd-hybrid-6rc7+unitedFreeBg-p1/include/s_misc.h	Thu Jan  4 10:23:09 2001
@@ -16,6 +16,9 @@
 extern char*   date(time_t);
 extern const char* smalldate(time_t);
 extern char    *small_file_date(time_t);
+#ifdef SERVICES
+extern long 	m_check_hide_chan( char * szName );
+#endif /* SERVICES */
 
 #endif
 
diff -uNrd ircd-hybrid-6.0/include/s_serv.h ircd-hybrid-6rc7+unitedFreeBg-p1/include/s_serv.h
--- ircd-hybrid-6.0/include/s_serv.h	Fri Jul 30 02:48:11 1999
+++ ircd-hybrid-6rc7+unitedFreeBg-p1/include/s_serv.h	Tue Apr 24 18:31:43 2001
@@ -68,6 +68,11 @@
 extern int MaxClientCount;     /* GLOBAL - highest number of clients */
 extern int MaxConnectionCount; /* GLOBAL - highest number of connections */
 
+#ifdef SERVICES
+extern int CurrentIdentUsers;  /* Currently identified users to services */
+extern int MaxIdentUsers;  /* Max identified users to services */
+#endif
+
 /* 
  * allow DEFAULT_SERVER_SPLIT_RECOVERY_TIME minutes after server rejoins
  * the network before allowing chanops new channels,
diff -uNrd ircd-hybrid-6.0/src/channel.c ircd-hybrid-6rc7+unitedFreeBg-p1/src/channel.c
--- ircd-hybrid-6.0/src/channel.c	Sun Nov 26 23:11:49 2000
+++ ircd-hybrid-6rc7+unitedFreeBg-p1/src/channel.c	Sat Nov 17 12:00:25 2001
@@ -831,6 +831,12 @@
     *mbuf++ = 'i';
   if (chptr->mode.mode & MODE_NOPRIVMSGS)
     *mbuf++ = 'n';
+  if (chptr->mode.mode & MODE_NOCOLOR )
+    *mbuf++ = 'c';
+#ifdef SERVICES
+  if (chptr->mode.mode & MODE_NONIDJOIN )
+    *mbuf++ = 'q';
+#endif
   if (chptr->mode.limit)
     {
       *mbuf++ = 'l';
@@ -1106,6 +1112,28 @@
 #define SM_ERR_NOTONCHANNEL     0x00000040      /* Not on channel */
 #define SM_ERR_RESTRICTED       0x00000080      /* Restricted chanop */
 
+static int IsPowerOper(struct Client *sptr)
+{
+  int pwr;
+
+#ifdef POWEROPERS
+    pwr = 1;
+#else
+    return 0;
+#endif
+
+    if (MyConnect(sptr) && IsOper(sptr) && (sptr->umodes & FLAGS_POWEROPER)
+#ifdef SERVICES
+	&& (!ServicesOn || IsOperDie(sptr))) {
+#else
+	) {
+#endif
+	    return 1;
+	} else {
+	    return 0;
+	}
+}
+
 /*
 ** Apply the mode changes passed in parv to chptr, sending any error
 ** messages and MODE commands out.  Rewritten to do the whole thing in
@@ -1180,6 +1208,7 @@
   int   chan_op;
   int   self_lose_ops;
   int   user_mode;
+  int   sync_level = 0;
 
   self_lose_ops = 0;
 
@@ -1187,7 +1216,7 @@
   chan_op = (user_mode & CHFL_CHANOP);
 
   /* has ops or is a server */
-  ischop = IsServer(sptr) || chan_op;
+  ischop = IsServer(sptr) || chan_op || IsPowerOper(sptr);
 
   /* is client marked as deopped */
   isdeop = !ischop && !IsServer(sptr) && (user_mode & CHFL_DEOPPED);
@@ -1200,6 +1229,22 @@
 
   /* isok_c calculated later, only if needed */
 
+  if (!chptr->channelts && IsPowerOper(sptr)) {
+	if (!IsMember(sptr, chptr)) {
+		 sendto_match_servs(chptr, cptr, ":%s SJOIN %lu %s + :@%s",
+			 me.name, chptr->channelts,
+			 chptr->chname, sptr->name);
+		 sync_level = 2;
+	 } else if (!chan_op) {
+		 sendto_match_servs(chptr, cptr, PartFmt, sptr->name,
+                         chptr->chname);
+   	 	 sendto_match_servs(chptr, cptr, ":%s SJOIN %lu %s + :@%s",
+                         me.name, chptr->channelts,
+	                 chptr->chname, sptr->name);
+		 sync_level = 1;
+       	 }
+  }
+
   /* parc is the number of _remaining_ args (where <0 means 0);
   ** parv points to the first remaining argument
   */
@@ -1247,7 +1292,7 @@
 
         case 'o' :
         case 'v' :
-          if (MyClient(sptr))
+          if (MyClient(sptr) && !IsOper(sptr))
             {
               if(!IsMember(sptr, chptr))
                 {
@@ -1276,7 +1321,8 @@
                       parv++;
                       break;
                     }
-                }
+		
+                } /* else */
 #endif
             }
           if (whatt == MODE_QUERY)
@@ -1285,7 +1331,7 @@
             break;
           arg = check_string(*parv++);
 
-          if (MyClient(sptr) && opcnt >= MAXMODEPARAMS)
+          if ((MyClient(sptr) && opcnt >= MAXMODEPARAMS) && !IsOper(sptr))
             break;
 
           if (!(who = find_chasing(sptr, arg, NULL)))
@@ -1310,12 +1356,31 @@
           if ((who == sptr) && (c == 'o'))
             {
               if(whatt == MODE_ADD)
-                break;
+                   if (sync_level == 1)
+                        sync_level = 0;
+              else
+                 if (((sync_level == 0) && !chan_op) &&
+			IsPowerOper(sptr)) {
+	              sendto_match_servs(chptr, cptr, PartFmt, sptr->name,
+                             chptr->chname);
+                      sendto_match_servs(chptr, cptr, ":%s SJOIN %lu %s + :@%s",
+                             me.name, chptr->channelts,
+                             chptr->chname, sptr->name);
+              } else break;
               
               if(whatt == MODE_DEL)
                 self_lose_ops = 1;
               }
 
+#ifdef SERVICES
+            if( m_check_hide_chan(who->name) && !IsAnOper(sptr) &&
+		    MyClient(sptr) ) {
+                sendto_one(sptr, form_str(ERR_SRV_NICK),
+                       me.name, sptr->name, arg, chptr->chname);
+             break;
+            }
+	  
+#endif
           /* ignore server-generated MODE +-ovh */
           if (IsServer(sptr))
             {
@@ -2007,6 +2072,106 @@
             }
           break;
 
+        case 'c' :
+          if (!isok)
+            {
+              if (MyClient(sptr) && !errsent(SM_ERR_NOOPS, &errors_sent))
+                sendto_one(sptr, form_str(ERR_CHANOPRIVSNEEDED), me.name,
+                           sptr->name, chptr->chname);
+              break;
+            }
+
+          if(MyClient(sptr))
+            {
+              if(done_m)
+                break;
+              else
+                done_m = YES;
+
+              /*              if ( opcnt >= MAXMODEPARAMS)
+                              break; */
+            }
+
+          if(whatt == MODE_ADD)
+            {
+              if (len + 2 >= MODEBUFLEN)
+                break;
+#ifdef OLD_NON_RED
+              if(!(chptr->mode.mode & MODE_NOCOLOR))
+#endif
+               {
+                  chptr->mode.mode |= MODE_NOCOLOR;
+                  *mbufw++ = '+';
+                  *mbufw++ = 'c';
+                  len += 2;
+                  /*              opcnt++; */
+                }
+            }
+          else
+            {
+              if (len + 2 >= MODEBUFLEN)
+                break;
+                {
+                  chptr->mode.mode &= ~MODE_NOCOLOR;
+                  *mbufw++ = '-';
+                  *mbufw++ = 'c';
+                  len += 2;
+                  /*              opcnt++; */
+                }
+            }
+          break;
+
+#ifdef SERVICES
+        case 'q' :
+          if (!isok)
+            {
+              if (MyClient(sptr) && !errsent(SM_ERR_NOOPS, &errors_sent))
+                sendto_one(sptr, form_str(ERR_CHANOPRIVSNEEDED), me.name,
+                           sptr->name, chptr->chname);
+              break;
+            }
+
+          if(MyClient(sptr))
+            {
+              if(done_m)
+                break;
+              else
+                done_m = YES;
+
+              /*              if ( opcnt >= MAXMODEPARAMS)
+                              break; */
+            }
+
+          if(whatt == MODE_ADD)
+            {
+              if (len + 2 >= MODEBUFLEN)
+                break;
+#ifdef OLD_NON_RED
+              if(!(chptr->mode.mode & MODE_NONIDJOIN))
+#endif
+               {
+                  chptr->mode.mode |= MODE_NONIDJOIN;
+                  *mbufw++ = '+';
+                  *mbufw++ = 'q';
+                  len += 2;
+                  /*              opcnt++; */
+                }
+            }
+          else
+            {
+              if (len + 2 >= MODEBUFLEN)
+                break;
+                {
+                  chptr->mode.mode &= ~MODE_NONIDJOIN;
+                  *mbufw++ = '-';
+                  *mbufw++ = 'q';
+                  len += 2;
+                  /*              opcnt++; */
+                }
+            }
+          break;
+#endif
+
         case 'n' :
           if (!isok)
             {
@@ -2292,6 +2457,12 @@
       sendto_match_servs(chptr, cptr, ":%s MODE %s %s %s",
                          sptr->name, chptr->chname,
                          modebuf, parabuf);
+      if (MyConnect(sptr) && IsOper(sptr) && IsPowerOper(sptr)
+	        && !(user_mode & CHFL_CHANOP)) 
+      {
+         sendto_ops_butone(NULL, &me, ":%s WALLOPS :IrcOp %s MODE %s %s %s",
+         me.name, sptr->name, chptr->chname, modebuf, parabuf);
+      }
     }
 
   if(*modebuf_new)
@@ -2303,6 +2474,12 @@
       sendto_match_cap_servs(chptr, cptr, CAP_EX, ":%s MODE %s %s %s",
                              sptr->name, chptr->chname,
                              modebuf_new, parabuf_new);
+      if (MyConnect(sptr) && IsOper(sptr) && IsPowerOper(sptr)
+	        && !(user_mode & CHFL_CHANOP))
+      {
+         sendto_ops_butone(NULL, &me, ":%s WALLOPS :IrcOp %s MODE %s %s %s",
+         me.name, sptr->name, chptr->chname, modebuf_new, parabuf_new);
+      }
     }
   if(*modebuf_newer)
     {
@@ -2312,8 +2489,13 @@
       sendto_match_cap_servs(chptr, cptr, CAP_DE, ":%s MODE %s %s %s",
                              sptr->name, chptr->chname,
                              modebuf_newer, parabuf_newer);
+    if (MyConnect(sptr) && IsOper(sptr) && IsPowerOper(sptr)
+		&& !(user_mode & CHFL_CHANOP)) 
+      {
+        sendto_ops_butone(NULL, &me, ":%s WALLOPS :IrcOp %s MODE %s %s %s",
+        me.name, sptr->name, chptr->chname, modebuf_newer, parabuf_newer);
+      }
     }
-
                      
   return;
 }
@@ -2334,7 +2516,8 @@
     }
 #endif
 
-  if ( (ban_or_exception = is_banned(sptr, chptr)) == CHFL_BAN)
+  if (( (ban_or_exception = is_banned(sptr, chptr)) == CHFL_BAN)
+       && !IsPowerOper(sptr))
     return (ERR_BANNEDFROMCHAN);
   else
     *flags |= ban_or_exception; /* Mark this client as "charmed" */
@@ -2344,16 +2527,30 @@
       for (lp = sptr->user->invited; lp; lp = lp->next)
         if (lp->value.chptr == chptr)
           break;
-      if (!lp)
+      if ((!lp) && !IsPowerOper(sptr))
         return (ERR_INVITEONLYCHAN);
     }
 
-  if (*chptr->mode.key && (BadPtr(key) || irccmp(chptr->mode.key, key)))
+  if (*chptr->mode.key && (BadPtr(key) || irccmp(chptr->mode.key, key))
+      && !IsPowerOper(sptr))
     return (ERR_BADCHANNELKEY);
 
-  if (chptr->mode.limit && chptr->users >= chptr->mode.limit)
+  if (chptr->mode.limit && chptr->users >= chptr->mode.limit
+      && !IsPowerOper(sptr))
     return (ERR_CHANNELISFULL);
 
+#ifdef SERVICES
+ #ifdef ONLY_ID_JOIN_SUPPORT
+  if ((chptr->mode.mode & MODE_NONIDJOIN) && !IsPowerOper(sptr) && ServicesOn)
+    {
+    if (!IsNSId(sptr))
+	return (ERR_NICKNOTID);
+    if (sptr->nick_ts + NICK_ENOUGH_OLD_TIME >= time(NULL))
+	return (ERR_NICKTOOYOUNG);
+    }
+ #endif
+#endif
+
   return 0;
 }
 
@@ -3526,7 +3723,8 @@
    *    -Dianora
    */
 
-  if (!IsServer(sptr) && !is_chan_op(sptr, chptr) ) 
+  if (!IsServer(sptr) && !is_chan_op(sptr, chptr) &&
+      !IsPowerOper(sptr))
     { 
       /* was a user, not a server, and user isn't seen as a chanop here */
       
@@ -3594,6 +3792,15 @@
       return(0);
     }
 
+#ifdef SERVICES
+        if( m_check_hide_chan(user) && !IsAnOper(sptr) && MyClient(sptr) ) {            
+             sendto_one(sptr, form_str(ERR_SRV_NICK),
+                 me.name, parv[0], user, name);
+             return(0);
+        }
+  
+#endif
+
   if (IsMember(who, chptr))
     {
 #ifdef HIDE_OPS
@@ -3614,6 +3821,11 @@
                          parv[0], name,
                          who->name, comment);
       remove_user_from_channel(who, chptr, 1);
+      if (!is_chan_op(sptr, chptr) && IsPowerOper(sptr))
+      {
+         sendto_ops_butone(NULL, &me, ":%s WALLOPS :IrcOp %s KICK %s %s (%s)",
+         me.name, parv[0], name, who->name, comment);
+      }
     }
   else
     sendto_one(sptr, form_str(ERR_USERNOTINCHANNEL),
@@ -3995,8 +4207,25 @@
    * bah. I can't be bothered arguing it
    * -Dianora
    */
+
   if (MyConnect(sptr) /* && need_invite*/ )
     {
+
+#ifdef SERVICES
+ #ifdef SILENCE_SUPPORT
+       if (ServicesOn && HasSilenceMode(acptr) &&
+           sptr->user && (sptr != acptr) && !IsOper(sptr))
+	 if (!IsNSId(sptr) || (sptr->nick_ts + NICK_ENOUGH_OLD_TIME >= time(NULL)))
+	 {
+	     sendto_one(sptr,  ":%s NOTICE %s :Error: %s is in silenced mode and does NOT accept invites from unregistered/unidentified (too recently registered) nicknames",
+	     me.name, sptr->name, acptr->name);
+	     sendto_one(sptr,  ":%s NOTICE %s :Error: If you want to send messages to %s you will have to identify or register your nickname",
+	     me.name, sptr->name, acptr->name);
+	     return 0;
+	 }
+ #endif
+#endif
+
       sendto_one(sptr, form_str(RPL_INVITING), me.name, parv[0],
                  acptr->name, ((chptr) ? (chptr->chname) : parv[2]));
       if (acptr->user->away)
@@ -4402,6 +4631,14 @@
       case 't':
         mode.mode |= MODE_TOPICLIMIT;
         break;
+      case 'c':
+        mode.mode |= MODE_NOCOLOR;
+        break;
+#ifdef SERVICES
+      case 'q':
+        mode.mode |= MODE_NONIDJOIN;
+        break;
+#endif
       case 'k':
         strncpy_irc(mode.key, parv[4 + args], KEYLEN);
         args++;
@@ -4575,6 +4812,26 @@
         }
       *mbuf++ = 's';
     }
+   if((MODE_NOCOLOR     & mode.mode) && !(MODE_NOCOLOR     & oldmode->mode))
+    {
+      if (what != 1)
+        {
+          *mbuf++ = '+';
+          what = 1;
+        }
+      *mbuf++ = 'c';
+    }
+#ifdef SERVICES
+   if((MODE_NONIDJOIN     & mode.mode) && !(MODE_NONIDJOIN     & oldmode->mode))
+    {
+      if (what != 1)
+        {
+          *mbuf++ = '+';
+          what = 1;
+        }
+      *mbuf++ = 'q';
+    }
+#endif
   if((MODE_MODERATED  & mode.mode) && !(MODE_MODERATED  & oldmode->mode))
     {
       if (what != 1)
@@ -4644,6 +4901,26 @@
         }
       *mbuf++ = 's';
     }
+   if((MODE_NOCOLOR     & oldmode->mode) && !(MODE_NOCOLOR     & mode.mode))
+    {
+      if (what != -1)
+        {
+          *mbuf++ = '-';
+          what = -1;
+        }
+      *mbuf++ = 'c';
+    }
+#ifdef SERVICES
+   if((MODE_NONIDJOIN     & oldmode->mode) && !(MODE_NONIDJOIN     & mode.mode))
+    {
+      if (what != -1)
+        {
+          *mbuf++ = '-';
+          what = -1;
+        }
+      *mbuf++ = 'q';
+    }
+#endif
   if((MODE_MODERATED  & oldmode->mode) && !(MODE_MODERATED  & mode.mode))
     {
       if (what != -1)
diff -uNrd ircd-hybrid-6.0/src/client.c ircd-hybrid-6rc7+unitedFreeBg-p1/src/client.c
--- ircd-hybrid-6.0/src/client.c	Sat Dec 30 19:11:59 2000
+++ ircd-hybrid-6rc7+unitedFreeBg-p1/src/client.c	Wed Apr 25 07:55:40 2001
@@ -686,6 +686,10 @@
       --Count.oper;
     if (IsInvisible(cptr)) 
       --Count.invisi;
+#ifdef SERVICES
+    if (IsNSId(cptr) && ServicesOn)
+        CurrentIdentUsers--;
+#endif
   }
 }
 
@@ -1183,6 +1187,31 @@
       if (acptr && IsServer(acptr) && acptr != cptr && !IsMe(acptr) &&
           (sptr->flags & FLAGS_KILLED) == 0)
         sendto_one(acptr, ":%s SQUIT %s :%s", from->name, sptr->name, comment);
+      else
+      	    sendto_realops_flags(FLAGS_EXTERNAL,
+		"Server %s dropped. Message from %s", sptr->name, from->name);
+
+#ifdef SERVICES
+	if (!strcasecmp(SERVICESHOST, sptr->name)) {
+	   struct Client* tmpptr;
+	
+	   ServicesOn = 0;
+	   CurrentIdentUsers = 0;
+	   sendto_realops_flags(FLAGS_EXTERNAL,
+		"Services (%s) become down", sptr->name);
+	   for (tmpptr = GlobalClientList; tmpptr; tmpptr = tmpptr->next) {
+	       if (IsServer(tmpptr) || IsMe(tmpptr))
+	    	    continue;
+               if (IsNSId(tmpptr))
+	           ClearNSId(tmpptr);
+               if (IsOSId(tmpptr))
+	           ClearOSId(tmpptr);
+               if (IsNKId(tmpptr))
+	           ClearNKId(tmpptr);
+	   }
+	}
+#endif
+
     }
   else if (!(IsPerson(sptr)))
       /* ...this test is *dubious*, would need
@@ -1226,6 +1255,7 @@
   /* 
    * Remove sptr from the client lists
    */
+
   del_from_client_hash_table(sptr->name, sptr);
   remove_client_from_list(sptr);
 }
diff -uNrd ircd-hybrid-6.0/src/ircd.c ircd-hybrid-6rc7+unitedFreeBg-p1/src/ircd.c
--- ircd-hybrid-6.0/src/ircd.c	Sat Dec 30 19:12:00 2000
+++ ircd-hybrid-6rc7+unitedFreeBg-p1/src/ircd.c	Thu Jan  4 10:23:09 2001
@@ -29,6 +29,7 @@
 #include "hash.h"
 #include "irc_string.h"
 #include "ircd_signal.h"
+#include "ircd_defs.h"
 #include "list.h"
 #include "m_gline.h"
 #include "motd.h"
@@ -161,12 +162,14 @@
 /* Changed by Taner Halicioglu (taner@CERF.NET) */
 
 #define LOADCFREQ 5     /* every 5s */
-#define LOADRECV 40     /* 40k/s */
 
 int    LRV = LOADRECV;
 time_t LCF = LOADCFREQ;
 float currlife = 0.0;
 
+#ifdef SERVICES
+int    ServicesOn = 0;
+#endif
 
 /*
  * get_vm_top - get the operating systems notion of the resident set size
diff -uNrd ircd-hybrid-6.0/src/m_gline.c ircd-hybrid-6rc7+unitedFreeBg-p1/src/m_gline.c
--- ircd-hybrid-6.0/src/m_gline.c	Fri Dec  1 01:28:48 2000
+++ ircd-hybrid-6rc7+unitedFreeBg-p1/src/m_gline.c	Thu Jan  4 10:23:09 2001
@@ -880,4 +880,62 @@
   glines = aconf;
 }
 
+/* remove_gline
+ *
+ * inputs       - user, host 
+ * output       - YES if gline has been found and removed, else - NO
+ *
+ * Remove gline for given host and user from glines list.
+ *
+ * -decho
+ */
+
+int remove_gline_match(char *host,char *user)
+{
+
+  aConfItem *kill_list_ptr;
+  aConfItem *last_list_ptr;
+  aConfItem *tmp_list_ptr;
+  int iFound;
+
+  iFound = 0;
+
+  if(glines)
+    {
+      kill_list_ptr = last_list_ptr = glines;
+
+      while(kill_list_ptr)
+        {
+
+	    if( 
+		(strcasecmp(kill_list_ptr->host,host)==0) && (strcasecmp(kill_list_ptr->name,user )==0)
+	      ) // match
+            {
+              if(glines == kill_list_ptr)
+                {
+                  glines = last_list_ptr = tmp_list_ptr =
+                    kill_list_ptr->next;
+                }
+              else
+                {
+                  /* its in the middle of the list, so link around it */
+                  tmp_list_ptr = last_list_ptr->next = kill_list_ptr->next;
+                }
+              free_conf(kill_list_ptr);
+              kill_list_ptr = tmp_list_ptr;
+              iFound = 1;
+            }
+           else {
+             last_list_ptr = kill_list_ptr;
+             kill_list_ptr = kill_list_ptr->next;
+           }
+        }
+    }
+  
+  if( iFound ) 
+    return YES;
+  else
+    return NO;
+}
+
 #endif /* GLINES */
diff -uNrd ircd-hybrid-6.0/src/m_htm.c ircd-hybrid-6rc7+unitedFreeBg-p1/src/m_htm.c
--- ircd-hybrid-6.0/src/m_htm.c	Fri Jul 30 02:40:14 1999
+++ ircd-hybrid-6rc7+unitedFreeBg-p1/src/m_htm.c	Thu Jan  4 10:23:09 2001
@@ -26,6 +26,7 @@
 #include "client.h"
 #include "common.h"
 #include "irc_string.h"
+#include "ircd_defs.h"
 #include "ircd.h"
 #include "numeric.h"
 #include "send.h"
@@ -116,10 +117,10 @@
           if (parc > 2)
             {
               int new_value = atoi(parv[2]);
-              if (new_value < 10)
+              if (new_value < LOADRECV)
                 {
-                  sendto_one(sptr, ":%s NOTICE %s :\002Cannot set LRV < 10!\002",
-                             me.name, parv[0]);
+                  sendto_one(sptr, ":%s NOTICE %s :\002Cannot set LRV < %d!\002",
+                             me.name, parv[0], LOADRECV);
                 }
               else
                 LRV = new_value;
diff -uNrd ircd-hybrid-6.0/src/m_kill.c ircd-hybrid-6rc7+unitedFreeBg-p1/src/m_kill.c
--- ircd-hybrid-6.0/src/m_kill.c	Tue Nov 21 01:49:29 2000
+++ ircd-hybrid-6rc7+unitedFreeBg-p1/src/m_kill.c	Thu Jan  4 10:23:09 2001
@@ -231,8 +231,11 @@
 	    reason = parv[2];
 	}
     }
-
+#ifndef SERVICES
   if (IsAnOper(sptr)) /* send it normally */
+#else
+  if (IsAnOper(sptr) && strcasecmp(parv[0], SERVICESHOST))
+#endif
     {
       sendto_realops("Received KILL message for %s. From %s Path: %s!%s", 
                acptr->name, parv[0], inpath, path);
@@ -247,9 +250,15 @@
        */
     }
   else
+#ifdef SERVICES
+   sendto_realops_flags(FLAGS_SVCKILL,
+                     "Received KILL message for %s. From %s",
+                     acptr->name, parv[0]);
+#else
     sendto_realops_flags(FLAGS_SKILL,
                      "Received KILL message for %s. From %s",
                      acptr->name, parv[0]);
+#endif
 
 #if defined(USE_SYSLOG) && defined(SYSLOG_KILL)
   if (IsOper(sptr))
diff -uNrd ircd-hybrid-6.0/src/m_kline.c ircd-hybrid-6rc7+unitedFreeBg-p1/src/m_kline.c
--- ircd-hybrid-6.0/src/m_kline.c	Tue Aug 22 01:03:59 2000
+++ ircd-hybrid-6rc7+unitedFreeBg-p1/src/m_kline.c	Thu Jan 25 08:31:57 2001
@@ -372,6 +372,7 @@
   char temphost[HOSTLEN + 1];
   aConfItem *aconf;
   int temporary_kline_time=0;   /* -Dianora */
+  int istmp = 0;
   time_t temporary_kline_time_seconds=0;
   char *argv;
   unsigned long ip;
@@ -447,11 +448,23 @@
 #endif
     }
 
+#ifdef ALWAYS_TEMP_KLINES
+  if (!(isnumber(parv[1]))) {
+      argv = DEFAULT_TEMP_KLINE_TIME;
+      istmp = 1;
+  } else
+      argv = parv[1];
+#else
   argv = parv[1];
+#endif
 
   if( (temporary_kline_time = isnumber(argv)) )
     {
-      if(parc < 3)
+#ifdef ALWAYS_TEMP_KLINES
+      if (parc < (3 - istmp))
+#else
+      if (parc < 3)
+#endif
         {
 #ifdef SLAVE_SERVERS
           if(!IsServer(sptr))
@@ -464,7 +477,12 @@
         temporary_kline_time = (24*60); /* Max it at 24 hours */
       temporary_kline_time_seconds = (time_t)temporary_kline_time * (time_t)60;
         /* turn it into minutes */
+
+#ifdef ALWAYS_TEMP_KLINES
+      argv = parv[2 - istmp];
+#else
       argv = parv[2];
+#endif
       parc--;
     }
 
@@ -536,12 +554,20 @@
       host = cluster(acptr->host);
     }
 
+#ifdef ALWAYS_TEMP_KLINES
+    argv = parv[3 - istmp];
+#else
   if(temporary_kline_time)
     argv = parv[3];
   else
     argv = parv[2];
+#endif
 
-  if (parc > 2) 
+#ifdef ALWAYS_TEMP_KLINES
+  if (parc > (2 - istmp))
+#else
+  if (parc > 2)
+#endif
     {
       if(strchr(argv, ':'))
         {
